"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var controller_base_1 = require("./controller-base");
var modal_custom_base_1 = require("./modal-custom-base");
var app_errors_1 = require("../app-errors");
var ModalBase = /** @class */ (function (_super) {
    __extends(ModalBase, _super);
    function ModalBase(name, templateURL, $injector, options) {
        var _this = this;
        var $rootScope = $injector.get("$rootScope");
        var $scope = $rootScope.$new();
        _this = _super.call(this, name, $injector, $scope, { manualInitCleanup: true }) || this;
        _this.modal = null;
        _this.customController = null;
        _this.templateURL = templateURL;
        _this.options = options;
        //Normally we expect users to subclass ModalBase in order to create custom controllers.
        //However if we need to dynamically create new controllers based on a string name like in the
        //gateway page, we need a way to find the appropriate controller programmatically using angular's
        //$injector.
        //
        //If we should use a custom controller, create that and attach it to our scope instead of ourselves
        if (options.customController != null) {
            var controllerService = $injector.get("$controller");
            _this.customController = controllerService(options.customController, { $scope: $scope });
            if (!(_this.customController instanceof modal_custom_base_1.CustomModalBase)) {
                _this.log_error("Attempted to create a modal with a custom controller that did not inherit from CustomModalBase", options.customController);
                throw new app_errors_1.ArgumentError("Invalid controller type specified: " + options.customController);
            }
            $scope.vm = _this.customController;
        }
        else {
            $scope.vm = _this; //Inject ourselves as vm so we can access our data from the template
        }
        _this.initialized = _this.createModal();
        var that = _this;
        $scope.$on('modal.removed', function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(that.customController != null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, that.customController.cleanup()];
                        case 1:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, that.cleanup()];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        });
        return _this;
    }
    ModalBase.prototype.createModal = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var that;
            return __generator(this, function (_a) {
                that = this;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        that.$ionicModal.fromTemplateUrl(_this.templateURL, {
                            scope: _this.$scope,
                            animation: _this.options.animation,
                            backdropClickToClose: _this.options.backdropClickToClose,
                            hardwareBackButtonClose: _this.options.hardwareBackButtonClose
                        }).then(function (modal) {
                            that.modal = modal;
                            if (that.customController) {
                                that.customController.modal = modal;
                            }
                            resolve();
                        }).catch(function (err) {
                            reject(err);
                        });
                    })];
            });
        });
    };
    ModalBase.prototype.show = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var that;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initialized];
                    case 1:
                        _a.sent();
                        that = this;
                        if (this.modal.isShown()) {
                            this.log_error("Show called multiple times");
                            return [2 /*return*/];
                        }
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                that.modal.show().then(function () {
                                    return __awaiter(this, void 0, void 0, function () {
                                        var err_1;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    _a.trys.push([0, 5, , 6]);
                                                    if (!(that.customController != null)) return [3 /*break*/, 2];
                                                    return [4 /*yield*/, that.customController.initialize()];
                                                case 1:
                                                    _a.sent();
                                                    return [3 /*break*/, 4];
                                                case 2: return [4 /*yield*/, that.initialize()];
                                                case 3:
                                                    _a.sent();
                                                    _a.label = 4;
                                                case 4:
                                                    resolve();
                                                    return [3 /*break*/, 6];
                                                case 5:
                                                    err_1 = _a.sent();
                                                    reject(err_1);
                                                    return [3 /*break*/, 6];
                                                case 6: return [2 /*return*/];
                                            }
                                        });
                                    });
                                });
                            })];
                }
            });
        });
    };
    ModalBase.prototype.hide = function () {
        return __awaiter(this, void 0, void 0, function () {
            var that;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initialized];
                    case 1:
                        _a.sent();
                        that = this;
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                that.modal.hide().then(resolve);
                            })];
                }
            });
        });
    };
    ModalBase.prototype.remove = function () {
        return __awaiter(this, void 0, void 0, function () {
            var that;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initialized];
                    case 1:
                        _a.sent();
                        that = this;
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                that.modal.remove().then(resolve);
                            })];
                }
            });
        });
    };
    return ModalBase;
}(controller_base_1.ControllerBase));
exports.ModalBase = ModalBase;
;
//# sourceMappingURL=modal-base.js.map